=== debian/changelog ===
ros-humble-ecal (5.12.0-2jammy) jammy; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Eclipse Foundation, Inc. <ecal-dev@eclipse.org>  Tue, 05 Sep 2023 11:58:54 -0000
